/*
 * tty-client  review.c
 *
 * Parsing of and handling of the review command.
 *
 *
 * Copyright (C) 1993  Lysator Computer Club,
 * 		       Linkoping University,  Sweden
 *
 *  Everyone is granted permission to copy, modify and redistribute
 *  this code, provided the people they give it to can.
 *
 *
 *  Author:	Linus Tolke
 * 		Lysator Computer Club
 *		Linkoping University
 *		Sweden
 *
 *  email	linus@lysator.liu.se
 *
 */


/* This is to emphasize that a function or variable is exported. */
#define Export

#include "review.h"

Export struct review *
review_parse(String argument) {
    rev = (struct review *) malloc(sizeof struct review);
    
    rev->by = NULL;
    rev->to = NULL;
    rev->before = NULL;
    rev->after = NULL;
    rev->direction = forward;
    rev->nobreak = FALSE;
    rev->textnos = NULL;
    rev->commenting = NULL;
    rev->comment_to = NULL;

    while (argument)
	{
...	parse and enter
    }
    return rev;
}


Export void
review_free(struct review * rev) {
    if (rev->by) {
	if (rev->by.what == and || rev->by.what == or) {
	    review_free((struct AndOrTree(Pers_no) *)rev->by.info.sub.a1);
	    review_free((struct AndOrTree(Pers_no) *)rev->by.info.sub.a2);
	}
	free(rev->by);
    }
    if (rev->to) {
	if (rev->to.what == and || rev->to.what == or) {
	    review_free((struct AndOrTree(Conf_no) *)rev->to.info.sub.a1);
	    review_free((struct AndOrTree(Conf_no) *)rev->to.info.sub.a2);
	}
	free(rev->to);
    }

    if (rev->before) {
	if (rev->before.what == and || rev->before.what == or) {
	    review_free((struct AndOrTree(Text_no) *)rev->before.info.sub.a1);
	    review_free((struct AndOrTree(Text_no) *)rev->before.info.sub.a2);
	}
	free(rev->before);
    }
    if (rev->after) {
	if (rev->after.what == and || rev->after.what == or) {
	    review_free((struct AndOrTree(Text_no) *)rev->after.info.sub.a1);
	    review_free((struct AndOrTree(Text_no) *)rev->after.info.sub.a2);
	}
	free(rev->after);
    }


    if (rev->textnos) {
	if (rev->textnos.what == and || rev->textnos.what == or) {
	    review_free((struct AndOrTree(Text_no) *)rev->textnos.info.sub.a1);
	    review_free((struct AndOrTree(Text_no) *)rev->textnos.info.sub.a2);
	}
	free(rev->textnos);
    }
    if (rev->commenting) {
	if (rev->commenting.what == and || rev->commenting.what == or) {
	    review_free((struct AndOrTree(Text_no) *)rev->commenting.info.sub.a1);
	    review_free((struct AndOrTree(Text_no) *)rev->commenting.info.sub.a2);
	}
	free(rev->commenting);
    }
    if (rev->comment_to) {
	if (rev->comment_to.what == and || rev->comment_to.what == or) {
	    review_free((struct AndOrTree(Text_no) *)rev->comment_to.info.sub.a1);
	    review_free((struct AndOrTree(Text_no) *)rev->comment_to.info.sub.a2);
	}
	free(rev->comment_to);
    }
    free(rev);
}
