/*
 * tty-client  review.h
 *
 * Parsing of and handling of the review command.
 *
 *
 * Copyright (C) 1993  Lysator Computer Club,
 * 		       Linkoping University,  Sweden
 *
 *  Everyone is granted permission to copy, modify and redistribute
 *  this code, provided the people they give it to can.
 *
 *
 *  Author:	Linus Tolke
 * 		Lysator Computer Club
 *		Linkoping University
 *		Sweden
 *
 *  email	linus@lysator.liu.se
 *
 */

#ifndef  REVIEW_H_ALREADY_INCLUDED__
#define  REVIEW_H_ALREADY_INCLUDED__

#include <s-string.h>
#include <kom-types.h>

/* This is to emphasize that a function or variable is exported. */
#define Export extern

typedef enum { and, or, info } AOT_type;
/* Fattigmans templates */
#define AndOrTree(type)	struct { AOT_type what; union { struct { struct * a1, a2; } sub; type info; } info; } *


enum { forward, backward } possible_direction;

struct review {
    AndOrTree(Pers_no)	by;
    AndOrTree(Conf_no)	to;
    AndOrTree(Text_no)	before;
    AndOrTree(Text_no)	after;
    possible_direction	direction;
    int			nobreak;
    AndOrTree(Text_no)	textnos;
    AndOrTree(Text_no)	commenting;
    AndOrTree(Text_no)	comment_to;
};

Export struct review *
review_parse(String);

Export void
review_free(struct review *);

#endif
